
//##############################################################################
//                   Warp Ship Code Originally by: VorteX8
//                        Credit for Partial Code:
//                          Bad Shot, The_Force
//                           Code Version: 0.90
//                        Suggestions by: Waxx IX
//                  Modified for UltimateBuild by: Krash123
//##############################################################################

function WarpStart(%this, %client)
{
   if (!isObject(%this))
      return;
   %veh = %this.getObjectMount();
   if (isObject(%veh))
   {
         if (%veh.getMountNodeObject(0) == %this)
         {
           %veh.setEnergyLevel(0);
           %veh.WarpPct = 0;
           %veh.inWarp = true;
           schedule(1000, %veh, WarpStart2, %veh, %client);
   }
}

function WarpStart2(%obj, %client)
{
 if (%obj.inWarp)
 {
   %obj.playShieldEffect("0.0 0.0 1.0");
   %obj.WarpPct += 1;
         %obj.schedule(500, "playThread", $ActivateThread, "activate");
		%obj.setThreadDir($ActivateThread,false);
        %obj.playThread($ActivateThread,"activate");
   %status = %obj.WarpPct;
   CommandToClient(%client, 'BottomPrint', "[ Powering Warp Field   " @ %status @ "% ]", 2, 1 );
   if (%obj.WarpPct <= 99)
      schedule(50,%obj, WarpStart2, %obj, %client);
   else
   {
      %obj.warpLoad = 0;
      schedule(1000,%obj, WarpStart3, %obj, %client);
   }
 }
}
 function WarpStart3(%obj, %client)
{
 if (%obj.inWarp)
 {
   %obj.playShieldEffect("1.0 1.0 0.0");
   %vec = %obj.getMuzzleVector(0);
   %vec = VectorNormalize(%vec);
   %objData = %obj.getDataBlock();
   %mass =  %objData.mass;
   if (%obj.getDatablock().getName() $= "ScoutWARP")
      %boost = %mass * 2;
   if (%obj.getDatablock().getName() $= "ScoutFlyer")
      %boost = %mass * 5;
   if (%obj.getDatablock().getName() $= "BomberWarp")
      %boost = %mass * 4;
   %obj.applyImpulse(posFromTransform(%obj.getTransform()), VectorScale(%vec, %boost));
   %obj.warpLoad += 1;
   %warpld = %obj.warpLoad;
   if (%obj.warpLoad <= 100)
   {
       CommandToClient(%client, 'BottomPrint', "\c2[ Diverting Power to Engines   " @ %warpLd @ "%]", 3, 1);
       schedule(50, %obj, WarpStart3, %obj, %client);
   }
   else
   {
       CommandToClient(%client, 'BottomPrint', "[ WARP ENGAGED ]", 2, 1);
       schedule(1500, %obj, WarpStart4, %obj, %client);
   }
 }
}

function WarpStart4(%obj, %client)
{
   %obj.warpLoad = 0;
   %obj.inWarp = true;
   %obj.stress = 0;
   %stress = %obj.stress;
   %obj.damage = 0;
   WarpThrust(%obj, %client);
}
function WarpThrust(%obj, %client)
{
   if (%obj.inWarp)
   {
      %obj.setEnergyLevel(100);
      %vec = %obj.getMuzzleVector(0);/
      %vec = VectorNormalize(%vec);
      %objData = %obj.getDataBlock();
      %mass =  %objData.mass;
      if (%obj.getDatablock().getName() $= "ScoutWARP")
         %boost = %mass * 8;
      if (%obj.getDatablock().getName() $= "ScoutFlyer")
         %boost = %mass * 10.5;
      %obj.applyImpulse(posFromTransform(%obj.getTransform()), VectorScale(%vec, %boost));
      %obj.playShieldEffect("10.0 10.0 10.0");
      %obj.stress += 0.15;
      %stress = %obj.stress;
      %speed = velToSingle(%obj.getVelocity());
      %spdshw = msToKPH(%speed);
      if (%obj.stress <= 80)
          CommandToClient(%client, 'BottomPrint', "\c2[ Warp Reactor Stress  " @ %stress @ "% ]\n [ Current Speed" @ %spdshw @ "kph ]", 1, 2);
      if (%obj.stress >= 80)
          CommandToClient(%client, 'BottomPrint', "\c2[ !CRITICAL WARP REACTOR STRESS! !Stress Damage!\n" @ %stress @ "% ||  "  @ %obj.damage @ "% ]\n [ Current Speed" @ %spdshw @ "kph ]", 1, 3);
      if (%obj.stress >= 100)
          %obj.damage += 1;
      if (%obj.damage >=100)
      {
          if(%obj.getDamageState() !$= Destroyed)
          {
               CommandToClient(%client, 'BottomPrint', "\c2 [ <<< WARP REACTOR BREECH >>> ]", 3, 1);
               %obj.inWarp = false;
               %obj.setDamageState(Destroyed);
          }
      }
      schedule(50, %obj, WarpThrust, %obj, %client);

   }
   else
   {
      WarpDown(%obj, %client);
   }
}
function WarpDown(%obj, %client)
{
   if (!isObject(%obj))
      return;
   %veh = %client.getObjectMount();
   if (isObject(%veh))
   {
         if (%veh.getMountNodeObject(0) == %client)
         {
            %veh.setEnergyLevel(1000);
            %veh.WarpPct = 0;
                    %veh.playThread($ActivateThread,"activate");
		            %veh.setThreadDir($ActivateThread,true);
                    %veh.playThread($ActivateThread,"activate");
                 }
   }
}

